> ## Documentation Index
> Fetch the complete documentation index at: https://docs.nmbr.co/llms.txt
> Use this file to discover all available pages before exploring further.

# Retrieve a report

> This endpoint allows you to retrieve the data associated with a specific report. Use the ULID provided when the report was originally generated to make the request.

To download the report in CSV format, include the `Accept` header with the value `text/csv` in your request. Alternatively, the rendered file can be retrieved from `GET /reports/{id}/download` using the `format` and `sheet` supplied at creation.



## OpenAPI

````yaml /spec/openapi.json get /reports/{report}
openapi: 3.0.0
info:
  title: Nmbr API
  description: API to interact with Nmbr Payroll
  version: 1.0.0
servers:
  - url: https://sandbox.nmbr.co/services/payroll
security:
  - CompanyToken: []
tags:
  - name: Accounting Codes
  - name: Accounting Code Rules
  - name: Adjustments
  - name: Allowances
  - name: Allowance Line Items
  - name: Allowance Types
  - name: Async Tasks
  - name: Bank Accounts
  - name: Business Entities
  - name: Business Entity Verifications
  - name: Business Entity ROE Authorizations
  - name: Business Presets
  - name: Calculations
  - name: Companies
  - name: Contractors
  - name: Deductions
  - name: Deduction Line Items
  - name: Deduction Types
  - name: Earnings
  - name: Earning Line Items
  - name: Earning Types
  - name: Effective Tax Properties
  - name: Employees
  - name: Employee Benefits
  - name: Employee Benefit Line Items
  - name: Employee Benefit Types
  - name: Employer Benefits
  - name: Employer Benefit Line Items
  - name: Employer Benefit Types
  - name: Employer Statutory Withholding Line Items
  - name: Employer Statutory Withholding Types
  - name: Forms
  - name: Form Batches
  - name: Form Types
  - name: Holidays
  - name: Integrations
  - name: Journal Entries
  - name: Overtime Rates
  - name: Partners
  - name: Pay Rates
  - name: Pay Schedules
  - name: Pay Splits
  - name: Pay Stubs
  - name: Payments
  - name: Payrolls
  - name: Reimbursements
  - name: Reimbursement Line Items
  - name: Reimbursement Types
  - name: Remittance Accounts
  - name: Remittance Account Enrollments
  - name: Reports
  - name: Statutory Withholding Line Items
  - name: Statutory Withholding Types
  - name: Tags
  - name: Tag Groups
  - name: Tax Properties
  - name: Tax Property Templates
  - name: Tokens
  - name: Usage Records
  - name: Usage Summaries
  - name: Vacation Pay
  - name: Vacation Pay Settings
  - name: Webhooks
  - name: Work Assignments
paths:
  /reports/{report}:
    get:
      tags:
        - Reports
      summary: Retrieve a report
      description: >-
        This endpoint allows you to retrieve the data associated with a specific
        report. Use the ULID provided when the report was originally generated
        to make the request.


        To download the report in CSV format, include the `Accept` header with
        the value `text/csv` in your request. Alternatively, the rendered file
        can be retrieved from `GET /reports/{id}/download` using the `format`
        and `sheet` supplied at creation.
      operationId: reports-show
      parameters:
        - name: report
          in: path
          schema:
            type: string
          required: true
        - name: sheet
          in: query
          schema:
            type: string
          required: false
          description: >-
            Specify the report sheet you want to retrieve when requesting the
            CSV format. When `sheet` was supplied at creation, that value takes
            precedence and this query param is ignored.
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                type: object
                properties:
                  id:
                    type: string
                    description: The unique identifier of the object in Nmbr.
                    readOnly: true
                  object:
                    type: string
                    description: The type of the object in Nmbr (`"report"`).
                    readOnly: true
                  data:
                    $ref: '#/components/schemas/Report'
              example:
                id: <id>
                object: report
                data:
                  type: liability
                  business_entity: null
                  pay_schedule: null
                  payroll:
                    id: <id>
                    object: payroll
                    links:
                      self: /payrolls/<id>
                  filters:
                    payroll_type: null
                    payroll_status: null
                    pay_date_from: null
                    pay_date_to: null
                    year: null
                  has_results: true
                  format: null
                  sheet: null
                  created_at: '2026-01-01T00:00:00.000000Z'
                  updated_at: '2026-01-01T00:00:00.000000Z'
                links:
                  self: /reports/<id>
components:
  schemas:
    Report:
      type: object
      title: Report
      properties:
        type:
          type: string
          enum:
            - cra-remittance
            - ei-cpp-balance
            - ei-qpp-qpip-balance
            - employer-health-tax
            - journal-entry
            - journal-entry-line-item
            - liability
            - payroll-register
            - rl1-preview
            - rq-remittance
            - t4-preview
            - vacation-accrual
            - workers-compensation
            - year-end-forms
            - year-to-date
        business_entity: {}
        pay_schedule: {}
        payroll:
          type: object
          properties:
            id:
              type: string
              description: The unique identifier of the object in Nmbr.
              readOnly: true
            object:
              type: string
              description: The type of the object in Nmbr (`"payroll"`).
              readOnly: true
        filters:
          type: object
          nullable: true
        has_results:
          type: boolean
        format:
          type: string
          description: >-
            The output format set at creation for `/download`. One of `csv` or
            `xlsx`. `null` when no format was specified — required to use
            `/download`.
          nullable: true
          maxLength: 255
          enum:
            - csv
            - pdf
            - xlsx
        sheet:
          type: string
          description: >-
            The sheet selected at creation for multi-sheet reports (e.g.
            `summary` or `detail` for Payroll Register). `null` when the report
            has a single sheet or no sheet was specified.
          nullable: true
          maxLength: 255
        created_at:
          type: string
          description: The date and time the object was created in Nmbr.
          readOnly: true
          format: dateTime
        updated_at:
          type: string
          description: The date and time the object was last updated in Nmbr.
          readOnly: true
          format: dateTime
  securitySchemes:
    CompanyToken:
      type: http
      scheme: bearer

````